#include <microhttpd.h>
#include <memory.h>
#include <stdio.h>

#define PAGE "<html><body>Hello world</body></html>"

static int ahc_echo(void *cls, struct MHD_Connection *cnc, const char *url, const char *method, const char *version,
                    const char *upload_data, size_t *upload_data_size, void **ptr) {
    const char *me = cls;
    struct MHD_Response *res;
    int ret;
    if ((void *) 1 != *ptr) {
        *ptr = (void *) 1;
        return MHD_YES;
    }
    *ptr = NULL;
    res = MHD_create_response_from_buffer(strlen(me), (void *) me, MHD_RESPMEM_PERSISTENT);
    ret = MHD_queue_response(cnc, MHD_HTTP_OK, res);
    MHD_destroy_response(res);
    return ret;
}

int main() {
    struct MHD_Daemon *d;
    d = MHD_start_daemon(MHD_USE_SELECT_INTERNALLY | MHD_SUPPRESS_DATE_NO_CLOCK, 8080, NULL, NULL,
                         &ahc_echo, PAGE, MHD_OPTION_END);
    while (1)
        sleep(1);
    MHD_stop_daemon(d);
    return 0;
}